/************************************************************************
*				HPUTILS.H				*
*			Header file for HPUTILS.C			*
*                    Copyright (C) 2003 Robert Tiismus                  *
*                         Robert.Tiismus@mail.ee                        *
*                       Last update:  03. Jun. 2003                     *
*                                                                       *
*  This program is free software; you can redistribute it and/or modify *
*  it under the terms of the GNU General Public License as published by *
*  the Free Software Foundation; either version 2 of the License, or    *
*  (at your option) any later version.                                  *
*                                                                       *
*  This program is distributed in the hope that it will be useful,      *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of       *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
*  GNU General Public License for more details.                         *
*                                                                       *
*  You should have received a copy of the GNU General Public License    *
*  along with this program; if not, write to the Free Software          *
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            *
************************************************************************/

typedef union
{ unsigned long hw[ 2 ];
  unsigned char bytes[ 8 ];
  unsigned b : 8;
  unsigned x : 12;
} hpword;

typedef struct
{ FILE *stream;
  unsigned char odd;
  int c;
  unsigned char type;
  unsigned char last_op;
} hpFILE; 

enum { RF, WF, RWF };
enum { R_OP, W_OP, N_OP };

// Model Number code
enum { UNKNOWN = 0, SSX = 1, GGX = 2 };

const char *obtype_str( long );
int skipob( long, hpFILE * );

int bint( hpFILE * );  int real( hpFILE * );
int erel( hpFILE * );  int cmp( hpFILE * );
int ecmp( hpFILE * );  int rrp( hpFILE * );
int tag( hpFILE * );   int acptr( hpFILE * );
int id( hpFILE * );    int lam( hpFILE * );
int xlib( hpFILE * );

int stdskip( hpFILE * );
int compskip( hpFILE * );

hpFILE *hp_fopen( const char *, const char * );
int     hp_fclose( hpFILE * );

int getnib( hpFILE * );
int hpget_b( hpFILE * );
int hpget_x( hpFILE * );
long hpget_a( hpFILE * );
hpword *hpget_w( hpFILE * );
char *hpget_name( hpFILE *in );
unsigned do_crc( hpFILE *, long );

void putnib( int, hpFILE * );
void hpput_b( int, hpFILE * );
void hpput_x( int, hpFILE * );
void hpput_a( long, hpFILE * );
void hpput_w( hpword, hpFILE * );

long hptell( hpFILE * );
int  hpseek( hpFILE *, long, int );
void hpsync_w( hpFILE * );

int model( char );

enum { DOBINT = 0x02911l, DOREAL    = 0x02933l, DOEREL = 0x02955l,
       DOCMP  = 0x02977l, DOECMP    = 0x0299Dl, DOCHAR = 0x029BFl,
       DOARRY = 0x029E8l, DOLNKARRY = 0x02A0Al, DOCSTR = 0x02A2Cl,
       DOHSTR = 0x02A4El, DOLIST    = 0x02A74l, DORRP  = 0x02A96l,
       DOSYMB = 0x02AB8l, DOEXT     = 0x02ADAl, DOTAG  = 0x02AFCl,
       DOGROB = 0x02B1El, DOLIB     = 0x02B40l, DOBAK  = 0x02B62l,
       DOEXT0 = 0x02B88l, DOACPTR   = 0x02BAAl, DOEXT2 = 0x02BCCl,
       DOEXT3 = 0x02BEEl, DOEXT4    = 0x02C10l, DOCOL  = 0x02D9Dl,
       DOCODE = 0x02DCCl, DOIDNT    = 0x02E48l, DOLAM  = 0x02E6Dl,
       DOROMP = 0x02E92l,
       SEMI   = 0x0312Bl,
       umEND  = 0x10B86l };
